---
title: DocumentOrShadowRoot.caretPositionFromPoint()
slug: Web/API/DocumentOrShadowRoot/caretPositionFromPoint
tags:
  - API
  - Document
  - DocumentOrShadowRoot
  - Method
  - Reference
  - ShadowRoot
  - caretPositionFromPoint()
---
<p>{{APIRef("CSSOM View")}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The <strong><code>caretPositionFromPoint()</code></strong> property of the {{domxref("DocumentOrShadowRoot")}} interface returns a {{domxref('CaretPosition')}} object, containing the DOM node, along with the caret and caret's character offset within that node.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var caretPosition = document.caretPositionFromPoint(float x, float y);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>The horizontal coordinate of a point.</dd>
 <dt><code>y</code></dt>
 <dd>The vertical coordinate of a point.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A {{domxref('CaretPosition')}} object.</p>

<h2 id="Example">Example</h2>

<p>This example inserts line breaks wherever you click. The code for it is below the demo.</p>

<h3 id="Demo">Demo</h3>

<p>{{EmbedLiveSample('Example', '100%', '300px')}}</p>

<h3 id="HTML_Content">HTML Content</h3>

<pre class="brush: html">&lt;p&gt;Lorem ipsum dolor sit amet, consetetur sadipscing elitr,
sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat,
sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum.
Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.&lt;/p&gt;</pre>

<h3 id="JavaScript_Content">JavaScript Content</h3>

<pre class="brush: js">function insertBreakAtPoint(e) {
  var range;
  var textNode;
  var offset;

  if (document.caretPositionFromPoint) {
    range = document.caretPositionFromPoint(e.clientX, e.clientY);
    textNode = range.offsetNode;
    offset = range.offset;
  } else if (document.caretRangeFromPoint) {
    range = document.caretRangeFromPoint(e.clientX, e.clientY);
    textNode = range.startContainer;
    offset = range.startOffset;
  }

  // only split TEXT_NODEs
  if (textNode.nodeType == 3) {
    var replacement = textNode.splitText(offset);
    var br = document.createElement('br');
    textNode.parentNode.insertBefore(br, replacement);
  }
}

window.onload = function (){
  var paragraphs = document.getElementsByTagName("p");
  for (i=0 ; i &lt; paragraphs.length; i++) {
    paragraphs[i].addEventListener("click", insertBreakAtPoint, false);
  }
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSSOM View','#dom-document-caretpositionfrompoint','caretPositionFromPoint()')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DocumentOrShadowRoot.caretPositionFromPoint")}}</p>
